#pragma once
#include <luna/StringView.h>
#include <luna/Vector.h>

class ArgumentParser
{
  public:
    ArgumentParser() = default;

    Result<void> add_positional_argument(StringView& out, StringView name, bool required);
    Result<void> add_positional_argument(StringView& out, StringView name, bool required, StringView fallback);

    Result<void> add_switch_argument(bool& out, char short_flag, StringView long_flag);

    void parse(int argc, char* const* argv);

  private:
    struct PositionalArgument
    {
        StringView* out;
        StringView name;
        bool required;
        StringView fallback;
    };

    struct SwitchArgument
    {
        bool* out;
        char short_flag;
        StringView long_flag;
    };

    Vector<PositionalArgument> m_positional_args;
    Vector<SwitchArgument> m_switch_args;
};
